## createrepo-c 0.17.4

=== CMakeLists.txt ===
PROJECT (createrepo_c C)
CMAKE_MINIMUM_REQUIRED (VERSION 2.6)

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS} -ggdb -g -Wall -Wextra -Og")
IF(NOT CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

IF(CMAKE_BUILD_TYPE AND CMAKE_BUILD_TYPE STREQUAL "DEBUG")
    MESSAGE("Build type is set do DEBUG! (Used flags: \"${CMAKE_C_FLAGS_DEBUG}\")")
ENDIF()


# Add path with own cmake modules

INCLUDE_DIRECTORIES (${CMAKE_SOURCE_DIR})
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

SET(G_LOG_DOMAIN "C_CREATEREPOLIB")

# Find necessary libraries

find_package(BZip2 REQUIRED)
find_package(CURL REQUIRED)
find_package(EXPAT REQUIRED)
find_package(GLIB2 REQUIRED)
find_package(GTHREAD2 REQUIRED)
find_package(Libmagic REQUIRED)
find_package(LibXml2 REQUIRED)
find_package(LZMA REQUIRED)
find_package(OpenSSL REQUIRED)
find_package(Sqlite3 REQUIRED)
find_package(ZLIB REQUIRED)

# Add include dirs

include_directories(${GLIB2_INCLUDE_DIRS})
include_directories(${LIBXML2_INCLUDE_DIR})


IF (RPM_PATH)
    SET (RPM_PATH "/home/tmlcoch/git/rpm")
    include_directories("${RPM_PATH}/include/")
    SET(RPMDB_LIBRARY "${RPM_PATH}/rpmio/.libs/librpmio.so"
                      "${RPM_PATH}/lib/.libs/librpm.so")
    message("Using custom RPM: ${RPMDB_LIBRARY}")
ELSE (RPM_PATH)
    # rpm:
    FIND_LIBRARY (RPMDB_LIBRARY NAMES rpmdb)
    IF (NOT RPMDB_LIBRARY)
        FIND_LIBRARY (RPMDB_LIBRARY NAMES rpm)
        IF (NOT RPMDB_LIBRARY)
            MESSAGE(FATAL_ERROR "No Rpm library installed")
        ENDIF (NOT RPMDB_LIBRARY)
    ENDIF (NOT RPMDB_LIBRARY)


    # rpmio:
    FIND_LIBRARY (RPMIO_LIBRARY NAMES rpmio)
    IF (RPMIO_LIBRARY)
        SET(RPMDB_LIBRARY ${RPMIO_LIBRARY} ${RPMDB_LIBRARY})
    ELSE (RPMIO_LIBRARY)
        MESSAGE(FATAL_ERROR "No Rpmio library installed")
    ENDIF (RPMIO_LIBRARY)

    message("Using system RPM: ${RPMDB_LIBRARY}")
ENDIF (RPM_PATH)

# SuSE legacy weak deps support
OPTION (ENABLE_LEGACY_WEAKDEPS "Enable legacy SUSE weakdeps support?" OFF)
IF (ENABLE_LEGACY_WEAKDEPS)
    ADD_DEFINITIONS("-DENABLE_LEGACY_WEAKDEPS=1")
ENDIF (ENABLE_LEGACY_WEAKDEPS)

# drpm
OPTION (ENABLE_DRPM "Enable delta RPM support?" ON)
IF (ENABLE_DRPM)
    if (DRPM_PATH)
        include_directories (${DRPM_PATH}/)
        find_library (DRPM_LIBRARY NAMES drpm PATHS ${DRPM_PATH}/ NO_DEFAULT_PATH)
        set(CR_DELTA_RPM_SUPPORT "1")
        message("Using custom DRPM: ${DRPM_LIBRARY}")
    ELSE (DRPM_PATH)
        FIND_LIBRARY (DRPM_LIBRARY NAMES drpm libdrpm.so.0)
        IF (NOT DRPM_LIBRARY)
            MESSAGE("No DRPM library installed")
        ELSE (NOT DRPM_LIBRARY)
            MESSAGE("Using DRPM library: ${DRPM_LIBRARY}")
            set(CR_DELTA_RPM_SUPPORT "1")
        ENDIF (NOT DRPM_LIBRARY)
    endif (DRPM_PATH)

    IF (CR_DELTA_RPM_SUPPORT)
        ADD_DEFINITIONS("-DCR_DELTA_RPM_SUPPORT")
    ENDIF (CR_DELTA_RPM_SUPPORT)
ENDIF (ENABLE_DRPM)

# option to enable/disable python support
OPTION (ENABLE_PYTHON "Enable python support?" ON)

# Threaded XZ Compression
# Note: This option is disabled by default, because Createrepo_c
# parallelize a lot of tasks (including compression) by default, this
# only adds extra threads on XZ library level which causes thread bloat
# and for most usecases doesn't bring any performance boost.
# On regular hardware (e.g. less-or-equal 4 cores) this option may even
# cause degradation of performance.
OPTION(ENABLE_THREADED_XZ_ENCODER "Enable threaded XZ encoder?" OFF)
IF (ENABLE_THREADED_XZ_ENCODER)
    ADD_DEFINITIONS("-DENABLE_THREADED_XZ_ENCODER=1")
ENDIF (ENABLE_THREADED_XZ_ENCODER)

# Get package version
INCLUDE (${CMAKE_SOURCE_DIR}/VERSION.cmake)
SET (VERSION "${CR_MAJOR}.${CR_MINOR}.${CR_PATCH}")
message("Package version: ${VERSION}")


# Other files

pkg_check_modules(BASHCOMP bash-completion)
if (BASHCOMP_FOUND)
    execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=completionsdir bash-completion OUTPUT_VARIABLE BASHCOMP_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
    message("Bash completion directory: ${BASHCOMP_DIR}")
    INSTALL(FILES createrepo_c.bash DESTINATION ${BASHCOMP_DIR} RENAME createrepo_c)
    INSTALL(CODE "
        execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink createrepo_c \$ENV{DESTDIR}${BASHCOMP_DIR}/mergerepo_c)
        execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink createrepo_c \$ENV{DESTDIR}${BASHCOMP_DIR}/modifyrepo_c)
        execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink createrepo_c \$ENV{DESTDIR}${BASHCOMP_DIR}/sqliterepo_c)
        ")
ELSE (BASHCOMP_FOUND)
    INSTALL(FILES createrepo_c.bash DESTINATION "/etc/bash_completion.d")
    message("Bash completion directory: /etc/bash_completion.d")
endif (BASHCOMP_FOUND)


# Gen manpage

#message("Gen manpage")
#execute_process(COMMAND bash gen_manpage.sh src/cmd_parser.c ../doc/ WORKING_DIRECTORY utils/)

# Add custom target for tests

ADD_CUSTOM_TARGET(tests)


# Subdirs

ADD_SUBDIRECTORY (src)
ADD_SUBDIRECTORY (doc)
ENABLE_TESTING()
ADD_SUBDIRECTORY (tests EXCLUDE_FROM_ALL)

=== src/CMakeLists.txt ===
SET (createrepo_c_SRCS
     checksum.c
     compression_wrapper.c
     createrepo_shared.c
     deltarpms.c
     dumper_thread.c
     error.c
     helpers.c
     load_metadata.c
     locate_metadata.c
     misc.c
     modifyrepo_shared.c
     package.c
     parsehdr.c
     parsepkg.c
     repomd.c
     sqlite.c
     threads.c
     updateinfo.c
     xml_dump.c
     xml_dump_deltapackage.c
     xml_dump_filelists.c
     xml_dump_other.c
     xml_dump_primary.c
     xml_dump_repomd.c
     xml_dump_updateinfo.c
     xml_file.c
     xml_parser.c
     xml_parser_filelists.c
     xml_parser_other.c
     xml_parser_primary.c
     xml_parser_repomd.c
     xml_parser_updateinfo.c)

SET(headers
    checksum.h
    compression_wrapper.h
    constants.h
    createrepo_c.h
    deltarpms.h
    error.h
    helpers.h
    load_metadata.h
    locate_metadata.h
    misc.h
    modifyrepo_shared.h
    package.h
    parsehdr.h
    parsepkg.h
    repomd.h
    sqlite.h
    threads.h
    updateinfo.h
    version.h
    xml_dump.h
    xml_file.h
    xml_parser.h)

ADD_LIBRARY(libcreaterepo_c SHARED ${createrepo_c_SRCS})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${BZIP2_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${CURL_LIBRARY})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${EXPAT_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${GLIB2_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${Libmagic_LIBRARY})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${LIBXML2_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${LZMA_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${OPENSSL_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${RPMDB_LIBRARY})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${SQLITE3_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${ZLIB_LIBRARY})
IF (DRPM_LIBRARY)
    TARGET_LINK_LIBRARIES(libcreaterepo_c ${DRPM_LIBRARY})
ENDIF (DRPM_LIBRARY)


SET_TARGET_PROPERTIES(libcreaterepo_c PROPERTIES
                      OUTPUT_NAME "createrepo_c"
                      SOVERSION ${CR_MAJOR}
                      VERSION "${VERSION}"
                      COMPILE_DEFINITIONS "G_LOG_DOMAIN=\"${G_LOG_DOMAIN}\"")

ADD_EXECUTABLE(createrepo_c createrepo_c.c cmd_parser.c)
TARGET_LINK_LIBRARIES(createrepo_c
                        libcreaterepo_c
                        ${GLIB2_LIBRARIES}
                        ${GTHREAD2_LIBRARIES})

ADD_EXECUTABLE(mergerepo_c mergerepo_c.c)
TARGET_LINK_LIBRARIES(mergerepo_c
                        libcreaterepo_c
                        ${GLIB2_LIBRARIES}
                        ${GTHREAD2_LIBRARIES})

ADD_EXECUTABLE(modifyrepo_c modifyrepo_c.c)
TARGET_LINK_LIBRARIES(modifyrepo_c
                        libcreaterepo_c
                        ${GLIB2_LIBRARIES}
                        ${GTHREAD2_LIBRARIES})

ADD_EXECUTABLE(sqliterepo_c sqliterepo_c.c)
TARGET_LINK_LIBRARIES(sqliterepo_c
                        libcreaterepo_c
                        ${GLIB2_LIBRARIES}
                        ${GTHREAD2_LIBRARIES})

CONFIGURE_FILE("createrepo_c.pc.cmake" "${CMAKE_SOURCE_DIR}/src/createrepo_c.pc" @ONLY)
CONFIGURE_FILE("version.h.in" "${CMAKE_CURRENT_SOURCE_DIR}/version.h" @ONLY)
CONFIGURE_FILE("deltarpms.h.in" "${CMAKE_CURRENT_SOURCE_DIR}/deltarpms.h" @ONLY)

IF (CMAKE_SIZEOF_VOID_P MATCHES "8")
    SET (LIB_SUFFIX "64")
ENDIF (CMAKE_SIZEOF_VOID_P MATCHES "8")
SET (LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")

INSTALL(FILES ${headers} DESTINATION "include/createrepo_c")
INSTALL(FILES "createrepo_c.pc" DESTINATION "${LIB_INSTALL_DIR}/pkgconfig")
INSTALL(TARGETS libcreaterepo_c LIBRARY DESTINATION ${LIB_INSTALL_DIR})
INSTALL(TARGETS createrepo_c DESTINATION bin/)
INSTALL(TARGETS mergerepo_c DESTINATION bin/)
INSTALL(TARGETS modifyrepo_c DESTINATION bin/)
INSTALL(TARGETS sqliterepo_c DESTINATION bin/)

IF (ENABLE_PYTHON)
ADD_SUBDIRECTORY(python)
ENDIF (ENABLE_PYTHON)

=== src/python/CMakeLists.txt ===
MACRO(PYTHON_UNSET)
    unset(PYTHON_LIBRARY)
    unset(PYTHON_INCLUDE_DIR)
    unset(PYTHON_EXECUTABLE)
    unset(PYTHON_LIBRARY CACHE)
    unset(PYTHON_INCLUDE_DIR CACHE)
    unset(PYTHON_EXECUTABLE CACHE)
ENDMACRO(PYTHON_UNSET)

PYTHON_UNSET()
SET(Python_ADDITIONAL_VERSIONS 3.0 CACHE INTERNAL "")
FIND_PACKAGE(PythonLibs 3 EXACT)
FIND_PACKAGE(PythonInterp 3 EXACT REQUIRED)


EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} -c "from sys import stdout; from distutils import sysconfig; stdout.write(sysconfig.get_python_lib(True))" OUTPUT_VARIABLE PYTHON_INSTALL_DIR)
INCLUDE_DIRECTORIES (${PYTHON_INCLUDE_PATH})

MESSAGE(STATUS "Python install dir is ${PYTHON_INSTALL_DIR}")

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-strict-aliasing")
set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fno-strict-aliasing")
set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -fno-strict-aliasing")

IF (${CMAKE_VERSION} VERSION_LESS "2.8.0")
    CONFIGURE_FILE(__init__.py "src/python/createrepo_c/__init__.py" COPYONLY)
ELSE()
    FILE(COPY __init__.py DESTINATION ./createrepo_c/)
ENDIF()

SET (createrepo_cmodule_SRCS
     checksum-py.c
     compression_wrapper-py.c
     contentstat-py.c
     createrepo_cmodule.c
     exception-py.c
     load_metadata-py.c
     locate_metadata-py.c
     misc-py.c
     package-py.c
     parsepkg-py.c
     repomd-py.c
     repomdrecord-py.c
     sqlite-py.c
     typeconversion.c
     updatecollection-py.c
     updatecollectionpackage-py.c
     updateinfo-py.c
     updaterecord-py.c
     updatereference-py.c
     xml_dump-py.c
     xml_file-py.c
     xml_parser-py.c
    )

ADD_LIBRARY(_createrepo_c SHARED ${createrepo_cmodule_SRCS})
SET_TARGET_PROPERTIES(_createrepo_c PROPERTIES PREFIX "")
SET_TARGET_PROPERTIES(_createrepo_c PROPERTIES LIBRARY_OUTPUT_DIRECTORY "./createrepo_c")
TARGET_LINK_LIBRARIES(_createrepo_c libcreaterepo_c)
TARGET_LINK_LIBRARIES(_createrepo_c
                        ${EXPAT_LIBRARIES}
                        ${CURL_LIBRARY}
                        ${PYTHON_LIBRARY}
                     )

INSTALL(FILES __init__.py DESTINATION ${PYTHON_INSTALL_DIR}/createrepo_c)
INSTALL(TARGETS _createrepo_c LIBRARY DESTINATION ${PYTHON_INSTALL_DIR}/createrepo_c)

=== tests/python/tests/CMakeLists.txt ===
# Detect nosetest version suffix
EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} -c "import sys; sys.stdout.write('%s.%s' % (sys.version_info[0], sys.version_info[1]))" OUTPUT_VARIABLE PYTHON_MAJOR_DOT_MINOR_VERSION)
SET(NOSETEST_VERSION_SUFFIX "-${PYTHON_MAJOR_DOT_MINOR_VERSION}")
message("-- nosetests program is nosetests${NOSETEST_VERSION_SUFFIX}")

execute_process(COMMAND which nosetests${NOSETEST_VERSION_SUFFIX}
                OUTPUT_QUIET ERROR_QUIET
                RESULT_VARIABLE NOSE_CHECK_RESULT)
IF (NOT NOSE_CHECK_RESULT STREQUAL "0")
    MESSAGE("Command 'nosetests${NOSETEST_VERSION_SUFFIX}' doesn't exist! Using only 'nosetests' instead")
    SET(NOSETEST_VERSION_SUFFIX "")
ENDIF()

CONFIGURE_FILE("run_nosetests.sh.in"  "${CMAKE_BINARY_DIR}/tests/python/tests/run_nosetests.sh")
ADD_TEST(test_python run_nosetests.sh -s ${CMAKE_CURRENT_SOURCE_DIR})

=== debian/changelog ===
createrepo-c (0.17.4) unstable; urgency=low

  * Upgrade version to 0.17.4 for Ubuntu22.04 distro.
  * port python version to python3.x version.
 -- Biao Wang <biao716.wang@samsung.com> Fri, 02  Dec 2022 11:07:00 +0900

=== debian/control ===
Source: createrepo-c
Section: devel
Priority: extra
Maintainer: Jian-feng Ding <jian-feng.ding@intel.com>
Build-Depends: debhelper (>= 7.0.15), cdbs, libpython3-dev, python3-dev, libpython3-all-dev, dh-python, python3-docutils, cmake, libbz2-dev, librpm-dev, liblzma-dev, libcurl3 | libcurl4, libcurl4-openssl-dev, libmagic-dev, libexpat1, doxygen, pkg-config, libglib2.0-dev, libssl-dev
Standards-Version: 0.17.4
Homepage: http://www.tizen.org

Package: createrepo-c
Architecture: any
Depends:
 libcreaterepo-c0 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Multi-Arch: foreign
Description: tool to create RPM repository metadata (C implementation)
 The createrepo_c tool generates the repodata directory and XML metadata that
 makes up a repository of RPM packages. This repository format is supported
 by apt-rpm, red-carpet(zen), smartpm, up2date, yast, and yum.
 .
 This package is similar to the apt-ftparchive or reprepro commands, but for
 working with RPM repositories.

Package: libcreaterepo-c0
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
 rpm,
 python3-rpm,
 python3-urlgrabber,
 cpio,
 bzip2,
 libpython3-dev,
 libcurl3 | libcurl4,
 libxml2,
 gzip,
 libglib2.0-0,
 libglib2.0-data,
 ${misc:Depends}
Multi-Arch: same
Description: library for creating RPM repository metadata
 The createrepo tool generates the repodata directory and XML metadata that
 makes up a repository of RPM packages. This repository format is supported
 by apt-rpm, red-carpet(zen), smartpm, up2date, yast, and yum.
 .
 This package contains a shared library for managing RPM repositories.

Package: libcreaterepo-c-dev
Section: libdevel
Architecture: any
Depends:
 libcreaterepo-c0 (= ${binary:Version}),
 libbz2-dev,
 libcurl4-openssl-dev,
 libglib2.0-dev,
 liblzma-dev,
 libmagic-dev,
 libpython3-dev,
 librpm-dev,
 libssl-dev,
 libsqlite3-dev,
 libxml2-dev,
 python3-nose,
 zlib1g-dev,
 ${misc:Depends}
Multi-Arch: same
Description: library for creating RPM repository metadata (development)
 The createrepo tool generates the repodata directory and XML metadata that
 makes up a repository of RPM packages. This repository format is supported
 by apt-rpm, red-carpet(zen), smartpm, up2date, yast, and yum.
 .
 This package contains the header files needed for developing programs
 using the libcreaterepo-c library.

Package: python3-createrepo-c
Section: python
Architecture: any
Depends:
 libcreaterepo-c0 (= ${binary:Version}),
 ${python3:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Multi-Arch: foreign
Description: library for creating RPM repository metadata (Python bindings)
 The createrepo tool generates the repodata directory and XML metadata that
 makes up a repository of RPM packages. This repository format is supported
 by apt-rpm, red-carpet(zen), smartpm, up2date, yast, and yum.
 .
 This package contains a Python module for interfacing with
 the libcreaterepo-c library.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.


#export DH_VERBOSE=1

build: build-stamp
build-stamp:
	dh_testdir
	cmake -DCMAKE_SKIP_RPATH=ON -DCMAKE_INSTALL_PREFIX=/usr -DENABLE_LEGACY_WEAKDEPS=ON
	make

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Installing package
	make DESTDIR=$(CURDIR) sysconfdir=$(CURDIR)/etc install
	mkdir -p $(CURDIR)/usr/lib
	if [ -e usr/lib64 ]; then cp -arf  usr/lib64/* $(CURDIR)/usr/lib/; fi
	#To compatible with createrepo
	for i in createrepo mergerepo modifyrepo sqliterepo;do \
		ln -s /usr/bin/$$i\_c $(CURDIR)/usr/bin/$$i; \
		echo ".so man8/$$i\_c.8" > $(CURDIR)/usr/share/man/man8/$$i\.8; \
	done
#	cat src/python/__init__.py
#	ls -R
binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_install
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
#	dh_shlibdeps -l/$(CURDIR)/usr/lib
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-arch: build install

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## createrepo-c 1.2.0

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED (VERSION 2.8.12)
PROJECT (createrepo_c C)

include(GNUInstallDirs)

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS} -ggdb -g -Wall -Wextra -Og")
IF(NOT CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

IF(CMAKE_BUILD_TYPE AND CMAKE_BUILD_TYPE STREQUAL "DEBUG")
    MESSAGE("Build type is set do DEBUG! (Used flags: \"${CMAKE_C_FLAGS_DEBUG}\")")
ENDIF()


option(BUILD_LIBCREATEREPO_C_SHARED "Build libcreaterepo_c as a shared library" ON)
if(NOT BUILD_LIBCREATEREPO_C_SHARED)
  set(CMAKE_POSITION_INDEPENDENT_CODE 1)
endif()

option(CREATEREPO_C_INSTALL_DEVELOPMENT "Install createrepo_c development files." ON)
option(CREATEREPO_C_INSTALL_MANPAGES "Install createrepo_c man-pages." ON)

# Add path with own cmake modules

INCLUDE_DIRECTORIES (${CMAKE_SOURCE_DIR})
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

SET(G_LOG_DOMAIN "C_CREATEREPOLIB")

# Find necessary libraries
find_package(PkgConfig)
find_package(BZip2 REQUIRED)
find_package(CURL REQUIRED)
find_package(LibXml2 REQUIRED)
find_package(OpenSSL REQUIRED)
find_package(ZLIB REQUIRED)

pkg_check_modules(GLIB2 REQUIRED glib-2.0)
pkg_check_modules(GIO REQUIRED gio-2.0)
pkg_check_modules(GTHREAD2 REQUIRED gthread-2.0)
pkg_check_modules(LZMA REQUIRED liblzma)
pkg_check_modules(SQLITE3 REQUIRED sqlite3>=3.6.18)
pkg_check_modules(RPM REQUIRED rpm)
pkg_check_modules(ZSTD REQUIRED libzstd)

# Add include dirs

include_directories(${BZIP2_INCLUDE_DIRS})
include_directories(${CURL_INCLUDE_DIRS})
include_directories(${GLIB2_INCLUDE_DIRS})
include_directories(${GIO_INCLUDE_DIRS})
include_directories(${LIBXML2_INCLUDE_DIR})
include_directories(${OPENSSL_INCLUDE_DIR})
include_directories(${ZLIB_INCLUDE_DIR})
include_directories(${ZSTD_INCLUDE_DIRS})

# SuSE/Mageia/Mandriva legacy weak deps support
OPTION (ENABLE_LEGACY_WEAKDEPS "Enable legacy SUSE/Mageia/Mandriva weakdeps support?" ON)
IF (ENABLE_LEGACY_WEAKDEPS)
    ADD_DEFINITIONS("-DENABLE_LEGACY_WEAKDEPS=1")
ENDIF (ENABLE_LEGACY_WEAKDEPS)

# Legacy hash functions
OPTION (WITH_LEGACY_HASHES "Build with SHA-1 and MD5 support" OFF)
IF (WITH_LEGACY_HASHES)
    ADD_DEFINITIONS("-DWITH_LEGACY_HASHES=1")
ENDIF (WITH_LEGACY_HASHES)

# drpm
OPTION (ENABLE_DRPM "Enable delta RPM support?" OFF)
IF (ENABLE_DRPM)
    pkg_check_modules(DRPM REQUIRED drpm>=0.4.0)
    include_directories (${DRPM_INCLUDE_DIRS})
    ADD_DEFINITIONS("-DCR_DELTA_RPM_SUPPORT")
ENDIF (ENABLE_DRPM)

# option to enable/disable python support
OPTION (ENABLE_PYTHON "Enable python support?" ON)

OPTION (WITH_ZCHUNK "Build with zchunk support" ON)
IF (WITH_ZCHUNK)
    pkg_check_modules(ZCK REQUIRED zck)
    include_directories(${ZCK_INCLUDE_DIRS})
    SET (CMAKE_C_FLAGS          "${CMAKE_C_FLAGS} -DWITH_ZCHUNK")
    SET (CMAKE_C_FLAGS_DEBUG    "${CMAKE_C_FLAGS_DEBUG} -DWITH_ZCHUNK")
ENDIF (WITH_ZCHUNK)

OPTION (WITH_LIBMODULEMD "Build with libmodulemd support" ON)
IF (WITH_LIBMODULEMD)
    pkg_check_modules(LIBMODULEMD REQUIRED modulemd-2.0)
    include_directories(${LIBMODULEMD_INCLUDE_DIRS})
    SET (CMAKE_C_FLAGS          "${CMAKE_C_FLAGS} -DWITH_LIBMODULEMD")
    SET (CMAKE_C_FLAGS_DEBUG    "${CMAKE_C_FLAGS_DEBUG} -DWITH_LIBMODULEMD")
ENDIF (WITH_LIBMODULEMD)


if (WITH_SANITIZERS)
    message(WARNING "Building with sanitizers enabled!")
    add_compile_options(-fsanitize=address -fsanitize=undefined -fsanitize=leak)
    link_libraries(asan ubsan)
endif()

# Threaded XZ Compression
# Note: This option is disabled by default, because Createrepo_c
# parallelize a lot of tasks (including compression) by default, this
# only adds extra threads on XZ library level which causes thread bloat
# and for most usecases doesn't bring any performance boost.
# On regular hardware (e.g. less-or-equal 4 cores) this option may even
# cause degradation of performance.
OPTION(ENABLE_THREADED_XZ_ENCODER "Enable threaded XZ encoder?" OFF)
IF (ENABLE_THREADED_XZ_ENCODER)
    ADD_DEFINITIONS("-DENABLE_THREADED_XZ_ENCODER=1")
ENDIF (ENABLE_THREADED_XZ_ENCODER)

# Get package version
INCLUDE (${CMAKE_SOURCE_DIR}/VERSION.cmake)
SET (VERSION "${CR_MAJOR}.${CR_MINOR}.${CR_PATCH}")
message("Package version: ${VERSION}")

# Other files

OPTION(ENABLE_BASHCOMP "Install Bash autocompletions?" ON)
IF (ENABLE_BASHCOMP)
    pkg_check_modules(BASHCOMP bash-completion)
    IF (BASHCOMP_FOUND)
        execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=completionsdir bash-completion OUTPUT_VARIABLE BASHCOMP_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
        message("Bash completion directory: ${BASHCOMP_DIR}")
        INSTALL(FILES createrepo_c.bash DESTINATION ${BASHCOMP_DIR} RENAME createrepo_c)
        INSTALL(CODE "
            execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink createrepo_c \$ENV{DESTDIR}${BASHCOMP_DIR}/mergerepo_c)
            execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink createrepo_c \$ENV{DESTDIR}${BASHCOMP_DIR}/modifyrepo_c)
            execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink createrepo_c \$ENV{DESTDIR}${BASHCOMP_DIR}/sqliterepo_c)
            ")
    ELSEIF (BASHCOMP_FOUND)
        INSTALL(FILES createrepo_c.bash DESTINATION "/etc/bash_completion.d")
        message("Bash completion directory: /etc/bash_completion.d")
    ENDIF (BASHCOMP_FOUND)
ENDIF (ENABLE_BASHCOMP)


# Gen manpage

#message("Gen manpage")
#execute_process(COMMAND bash gen_manpage.sh src/cmd_parser.c ../doc/ WORKING_DIRECTORY utils/)

# Add custom target for tests

ADD_CUSTOM_TARGET(tests)


# Subdirs

ADD_SUBDIRECTORY (src)
ADD_SUBDIRECTORY (doc)
ENABLE_TESTING()
ADD_SUBDIRECTORY (tests EXCLUDE_FROM_ALL)

=== src/python/CMakeLists.txt ===
MACRO(PYTHON_UNSET)
    unset(PYTHON_LIBRARY)
    unset(PYTHON_INCLUDE_DIR)
    unset(PYTHON_EXECUTABLE)
    unset(PYTHON_LIBRARY CACHE)
    unset(PYTHON_INCLUDE_DIR CACHE)
    unset(PYTHON_EXECUTABLE CACHE)
ENDMACRO(PYTHON_UNSET)

if (NOT SKBUILD)
    PYTHON_UNSET()
    SET(Python_ADDITIONAL_VERSIONS 3.0 CACHE INTERNAL "")
    FIND_PACKAGE(PythonInterp 3 REQUIRED)
    FIND_PACKAGE(PythonLibs 3 REQUIRED)
endif (NOT SKBUILD)

EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} -c "from sys import stdout; from sysconfig import get_path; stdout.write(get_path('platlib'))" OUTPUT_VARIABLE PYTHON_INSTALL_DIR)
INCLUDE_DIRECTORIES (${PYTHON_INCLUDE_PATH})

MESSAGE(STATUS "Python install dir is ${PYTHON_INSTALL_DIR}")

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-strict-aliasing")
set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fno-strict-aliasing")
set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -fno-strict-aliasing")

SET (createrepo_cmodule_SRCS
     checksum-py.c
     compression_wrapper-py.c
     contentstat-py.c
     createrepo_cmodule.c
     exception-py.c
     load_metadata-py.c
     locate_metadata-py.c
     misc-py.c
     package-py.c
     parsepkg-py.c
     repomd-py.c
     repomdrecord-py.c
     sqlite-py.c
     typeconversion.c
     updatecollection-py.c
     updatecollectionmodule-py.c
     updatecollectionpackage-py.c
     updateinfo-py.c
     updaterecord-py.c
     updatereference-py.c
     xml_dump-py.c
     xml_file-py.c
     xml_parser-py.c
    )

ADD_LIBRARY(_createrepo_c SHARED ${createrepo_cmodule_SRCS})
SET_TARGET_PROPERTIES(_createrepo_c PROPERTIES PREFIX "")
SET_TARGET_PROPERTIES(_createrepo_c PROPERTIES LIBRARY_OUTPUT_DIRECTORY "./createrepo_c")
TARGET_LINK_LIBRARIES(_createrepo_c libcreaterepo_c)
TARGET_LINK_LIBRARIES(_createrepo_c
                        ${CURL_LIBRARY}
                     )

IF (SKBUILD)
    find_package(PythonExtensions REQUIRED)
    python_extension_module(_createrepo_c)
ELSE ()
    TARGET_LINK_LIBRARIES(_createrepo_c ${PYTHON_LIBRARY})
ENDIF ()

IF (NOT SKBUILD)
    FILE(COPY createrepo_c/__init__.py DESTINATION createrepo_c)
ENDIF()

IF (SKBUILD)
    INSTALL(FILES createrepo_c/__init__.py DESTINATION src/python/createrepo_c)
    INSTALL(TARGETS _createrepo_c LIBRARY DESTINATION src/python/createrepo_c)
ELSE ()
    INSTALL(FILES createrepo_c/__init__.py DESTINATION ${PYTHON_INSTALL_DIR}/createrepo_c)
    INSTALL(TARGETS _createrepo_c LIBRARY DESTINATION ${PYTHON_INSTALL_DIR}/createrepo_c)

    # Version has to be passed as last argument.
    INSTALL(CODE "EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/utils/setup_for_python_metadata.py install_egg_info --install-dir \$ENV{DESTDIR}/${PYTHON_INSTALL_DIR} ${VERSION})")
ENDIF ()

=== tests/python/tests/CMakeLists.txt ===
CONFIGURE_FILE("run_unittests.sh.in"  "${CMAKE_BINARY_DIR}/tests/python/tests/run_unittests.sh")
ADD_TEST(test_python run_unittests.sh -s ${CMAKE_CURRENT_SOURCE_DIR})

=== debian/changelog ===
createrepo-c (1.2.0-3) unstable; urgency=medium

  * Fix FTBFS with CMake 4:
    - add the cmake-imported-target upstream patch which, besides fixing
      a bug, also bumps the minimum policy version to 3.7
    - add the cmake-doxygen-conditional upstream patch
    - Closes: #1112811
  * Declare compliance with Policy 4.7.2 with no changes.
  * Convert the watch file to version 5 of the format.
  * Minor changes to the ways linters are run (outside of Debian) on
    the autopkgtest program:
    - switch to uvoxen for running the tests
    - no longer declare Python 3.9 as supported
    - use Ruff 0.13.3 with no changes
  * Enable more tests for Salsa CI.

 -- Peter Pentchev <roam@debian.org>  Sun, 05 Oct 2025 17:39:03 +0300

createrepo-c (1.2.0-2) unstable; urgency=medium

  * Silly me, libcreaterepo-c1 is NEW, it needs a binary upload.

 -- Peter Pentchev <roam@debian.org>  Wed, 29 Jan 2025 04:20:26 +0200

createrepo-c (1.2.0-1) unstable; urgency=medium

  [ Loren M. Lang ]
  * New upstream version 1.2.0
  * Updated patches for latest import
  * Library SONAME bump
  * Updated symbol list for libcreaterepo-c
  * Updated copyright for createrepo-c-1.2.0
  * Updated patches for latest import
  * Library SONAME bump
  * Updated symbol list for libcreaterepo-c
  * Updated copyright for createrepo-c-1.2.0
  * Update changelog for 1.2.0-1 release

  [ Peter Pentchev ]
  * autopkgtest: use Ruff 0.9.3, override a docstring check.
  * Use debputy's X-Style: black.
  * Add the year 2025 to my debian/* copyright notice.

 -- Peter Pentchev <roam@debian.org>  Wed, 29 Jan 2025 03:19:32 +0200

createrepo-c (0.17.3-6) unstable; urgency=medium

  * Team upload.
  * autopkgtest: add missing dependencies on file and elfutils
  * autopkgtest: disable debuginfo package

 -- Luca Boccassi <bluca@debian.org>  Mon, 14 Oct 2024 23:30:04 +0100

=== debian/control ===
Source: createrepo-c
Section: utils
Priority: optional
Maintainer: RPM packaging team <team+pkg-rpm@tracker.debian.org>
Uploaders:
 Peter Pentchev <roam@debian.org>,
Build-Depends:
 debhelper (>> 13.15.2~),
 dh-package-notes,
 dh-sequence-python3,
 dpkg-build-api (= 1),
 bash-completion,
 check <!nocheck>,
 cmake,
 libbz2-dev,
 libcurl4-openssl-dev,
 libdrpm-dev,
 libglib2.0-dev,
 liblzma-dev,
 libmagic-dev,
 libmodulemd-dev,
 librpm-dev,
 libsqlite3-dev,
 libssl-dev,
 libxml2-dev,
 libzck-dev,
 python3-click <!nocheck>,
 python3-dev,
 python3-setuptools,
 python3-skbuild,
 rpm <!nocheck>,
 zchunk <!nocheck>,
 zlib1g-dev,
X-DH-Compat: 14
Standards-Version: 4.7.2
Homepage: https://github.com/rpm-software-management/createrepo_c/
Vcs-Git: https://salsa.debian.org/pkg-rpm-team/createrepo-c.git
Vcs-Browser: https://salsa.debian.org/pkg-rpm-team/createrepo-c
X-Style: black

Package: createrepo-c
Architecture: any
Depends:
 libcreaterepo-c1 (= ${binary:Version}),
Multi-Arch: foreign
Description: tool to create RPM repository metadata (C implementation)
 The createrepo_c tool generates the repodata directory and XML metadata that
 makes up a repository of RPM packages. This repository format is supported
 by apt-rpm, red-carpet(zen), smartpm, up2date, yast, and yum.
 .
 This package is similar to the apt-ftparchive or reprepro commands, but for
 working with RPM repositories.

Package: libcreaterepo-c1
Section: libs
Architecture: any
Multi-Arch: same
Description: library for creating RPM repository metadata
 The createrepo tool generates the repodata directory and XML metadata that
 makes up a repository of RPM packages. This repository format is supported
 by apt-rpm, red-carpet(zen), smartpm, up2date, yast, and yum.
 .
 This package contains a shared library for managing RPM repositories.

Package: libcreaterepo-c-dev
Section: libdevel
Architecture: any
Depends:
 libbz2-dev,
 libcreaterepo-c1 (= ${binary:Version}),
 libcurl4-openssl-dev,
 libglib2.0-dev,
 liblzma-dev,
 libmagic-dev,
 libpython3-dev,
 librpm-dev,
 libsqlite3-dev,
 libssl-dev,
 libxml2-dev,
 zlib1g-dev,
Multi-Arch: same
Description: library for creating RPM repository metadata (development)
 The createrepo tool generates the repodata directory and XML metadata that
 makes up a repository of RPM packages. This repository format is supported
 by apt-rpm, red-carpet(zen), smartpm, up2date, yast, and yum.
 .
 This package contains the header files needed for developing programs
 using the libcreaterepo-c library.

Package: python3-createrepo-c
Section: python
Architecture: any
Depends:
 libcreaterepo-c1 (= ${binary:Version}),
Multi-Arch: foreign
Description: library for creating RPM repository metadata (Python bindings)
 The createrepo tool generates the repodata directory and XML metadata that
 makes up a repository of RPM packages. This repository format is supported
 by apt-rpm, red-carpet(zen), smartpm, up2date, yast, and yum.
 .
 This package contains a Python module for interfacing with
 the libcreaterepo-c library.

=== debian/rules ===
#!/usr/bin/make -f

# Aim for the top, adapt if anything should break on the buildds.
DEB_BUILD_MAINT_OPTIONS=	hardening=+all future=+lfs

include /usr/share/dpkg/default.mk

include /usr/share/debhelper/dh_package_notes/package-notes.mk

D=	${CURDIR}/debian

%:
	dh "$@" --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_DRPM=ON -DENABLE_PYTHON=ON -DSKBUILD=ON

execute_after_dh_auto_test:
	env \
		PYTHONPATH='obj-${DEB_HOST_GNU_TYPE}/src/python' \
		PATH="${CURDIR}/obj-${DEB_HOST_GNU_TYPE}/src:$$PATH" \
		LD_LIBRARY_PATH='${CURDIR}/obj-${DEB_HOST_GNU_TYPE}/src' \
		python3 -B '$D/tests/repotest.py' --source '$D/tests/pkg/foo-0.1.0' --spec '$D/tests/pkg/foo.spec'

override_dh_makeshlibs:
	dh_makeshlibs -- -c4

override_dh_auto_clean:
	rm -rf src/createrepo_c.egg-info
	dh_auto_clean

=== debian/tests/control ===
Test-Command: python3 debian/tests/repotest.py --source debian/tests/pkg/foo-0.1.0 --spec debian/tests/pkg/foo.spec
Depends:
 elfutils,
 file,
 gcc,
 make,
 python3,
 python3-click,
 rpm,
 tar,
 @,
Restrictions:
 allow-stderr,
Features:
 test-name=repotest,

=== debian/watch ===
Version: 5

Source: https://github.com/rpm-software-management/createrepo_c/tags
Matching-Pattern: .*/v?(\d\S+)\.tar\.gz
Filename-Mangle: s/.+\/v?(\d\S+)\.tar\.gz/createrepo_c-$1\.tar\.gz/

## createrepo-c 1.2.1

=== debian/changelog ===
createrepo-c (1.2.1-2build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 23 Jan 2026 14:43:44 +0000

createrepo-c (1.2.1-2) unstable; urgency=medium

  * Declare Standards-Version 4.7.3, drop the implied Priority: optional.
  * Add the year 2026 to my debian/* copyright notice.
  * Use the GitHub template in the watch file.

 -- Peter Pentchev <roam@debian.org>  Wed, 07 Jan 2026 10:52:09 +0200

createrepo-c (1.2.1-1) unstable; urgency=medium

  * Add the upstream-rpm-hdrid patch to fix FTBFS with recent
    versions of rpm. Closes: #1122400
  * Add a superficial `debputy reformat` autopkgtest.
  * Rebuild with debhelper 13.29 for Multi-Arch: same for
    the -dbgsym packages.
  * New upstream release.
  * Minor changes to invoking the Python linters on the autopkgtest
    tool (not invoked during the Debian build).

 -- Peter Pentchev <roam@debian.org>  Fri, 19 Dec 2025 12:55:01 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: createrepo-c
 Section: utils
-Priority: optional
 Maintainer: RPM packaging team <team+pkg-rpm@tracker.debian.org>
 Uploaders:
  Peter Pentchev <roam@debian.org>,
@@ -32,7 +31,7 @@
  zchunk <!nocheck>,
  zlib1g-dev,
 X-DH-Compat: 14
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/rpm-software-management/createrepo_c/
 Vcs-Git: https://salsa.debian.org/pkg-rpm-team/createrepo-c.git
 Vcs-Browser: https://salsa.debian.org/pkg-rpm-team/createrepo-c

=== debian/watch ===
Version: 5

Template: GitHub
Owner: rpm-software-management
Project: createrepo_c
